import com.ibm.xml.parser.Attlist;
import com.ibm.xml.parser.AttDef;
import com.ibm.xml.parser.CMLeaf;
import com.ibm.xml.parser.CMNode;
import com.ibm.xml.parser.CM1op;
import com.ibm.xml.parser.CM2op;
import com.ibm.xml.parser.ContentModel;
import com.ibm.xml.parser.DTD;
import com.ibm.xml.parser.ElementDecl;
import com.ibm.xml.parser.TXDocument;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;


public class SQLXDocument extends com.ibm.xml.parser.TXDocument
{
private SQLXResults results=null;
public static final String ROWSET="rowset";
public static final String ROW="row";
public static final String VALUE="value";
public static final String TYPE="type";

public SQLXDocument(SQLXResults aSQLXResults) throws java.sql.SQLException
{
	super();
	setResults(aSQLXResults);
	if(getResults().getResultSet()!=null)
		buildXML();
}

private void buildDTD() throws java.sql.SQLException
{
	DTD dtd=this.createDTD();
	dtd.setName(ROWSET);

	CMNode cmNode=new CM1op('*',new CMLeaf(ROW));
	ContentModel
	contentModel=this.createContentModel(ElementDecl.MODEL_GROUP);
	contentModel.setContentModelNode(cmNode);
	ElementDecl rowset=this.createElementDecl(ROWSET,contentModel);
	dtd.appendChild(rowset);

	cmNode=new CMLeaf(getResults().getResultSet().getMetaData().getColumnName(1));
	for(int i=2;i<=getResults().getResultSet().getMetaData().getColumnCount();i++)
	{
		cmNode=new CM2op(',',cmNode,new CMLeaf(getResults().getResultSet().getMetaData().getColumnName(i)));
		
	}

	contentModel=this.createContentModel(ElementDecl.MODEL_GROUP);
	contentModel.setContentModelNode(cmNode);
	ElementDecl row=this.createElementDecl(ROW,contentModel);
	dtd.appendChild(row);

	for(int i=1;i<=getResults().getResultSet().getMetaData().getColumnCount();i++)
	{
		ElementDecl column=this.createElementDecl(getResults().getResultSet().getMetaData().getColumnName(i),this.createContentModel(Node.ELEMENT_NODE));
		column.setContentType(ElementDecl.EMPTY);
		dtd.appendChild(column);
		
		Attlist attlist=this.createAttlist(getResults().getResultSet().getMetaData().getColumnName(i));
		AttDef value=this.createAttDef(VALUE);
		value.setDeclaredType(AttDef.CDATA);
		value.setDefaultType(AttDef.IMPLIED);
		attlist.addElement(value);
		AttDef type=this.createAttDef(TYPE);
		type.setDeclaredType(AttDef.CDATA);
		type.setDefaultType(AttDef.FIXED);	
		type.setDefaultStringValue(" "+getResults().getResultSet().getMetaData().getColumnType(i));
		attlist.addElement(type);
		dtd.appendChild(attlist);
	}
	
this.appendChild(dtd);
}


private void buildXML() throws java.sql.SQLException
{
	boolean rowAdded=false;
	Element rowset=this.createElement(ROWSET);
	while(getResults().getResultSet().next())
	{
		rowAdded=true;
		Element row=this.createElement(ROW);
		rowset.appendChild(row);
		
		 for(int i=1;i<=getResults().getResultSet().getMetaData().getColumnCount();i++)
        	{ 
			String colName=getResults().getResultSet().getMetaData().getColumnName(i);
			Element col=this.createElement(colName);
			col.setAttribute(VALUE,getResults().getResultSet().getString(i));
			row.appendChild(col);
		}
	}
	
	if(rowAdded=true)
	{
		this.setVersion("1.0");
		buildDTD();
		this.appendChild(rowset);
	}
}


public SQLXResults getResults()
{
	return results;
}

public void setResults(SQLXResults param)
{
	results=param;
}
}

